## chibi-scheme 0.9.1

=== CMakeLists.txt ===
#
# FIXME: This CMakeLists.txt is only for Win32 platforms for now
#

cmake_minimum_required(VERSION 2.8.7)
project(chibi-scheme)

include(CheckIncludeFile)

#
# Version setting
#

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/RELEASE release)
string(STRIP ${release} release)

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/VERSION rawversion)
string(STRIP ${rawversion} rawversion)
set(version "${rawversion}-cmake")

set(chibischemelib "chibi-scheme-${rawversion}")

if(APPLE)
    message(FATAL_ERROR 
        "DYLD platforms are not supported with this CMakeLists.txt. Use Makefile instead.")
endif()

if(UNIX)
    message(FATAL_ERROR 
        "UNIX platforms are not supported with this CMakeLists.txt. Use Makefile instead.")
endif()

#
# Features
#

check_include_file(poll.h HAVE_POLL_H)
check_include_file(stdint.h HAVE_STDINT_H)
# option(CHIBI_SCHEME_USE_DL "Use dynamic loading" ON)
set(CHIBI_SCHEME_USE_DL OFF)
option(CHIBI_SCHEME_SHARED "Build chibi-scheme as a shared library" ON)

if(NOT CHIBI_SCHEME_SHARED)
    add_definitions(-DSEXP_STATIC_LIBRARY=1)
endif()

if(CHIBI_SCHEME_USE_DL)
    add_definitions(-DSEXP_USE_DL=1)
else()
    add_definitions(-DSEXP_USE_DL=0)
endif()

if(HAVE_STDINT_H)
    add_definitions(-DSEXP_USE_INTTYPES=1)
endif()

if(NOT HAVE_POLL_H)
    # Disable green threads: It depends on non-blocking I/O
    add_definitions(-DSEXP_USE_GREEN_THREADS=0)
endif()

set(chibi-scheme-exclude-modules)
if(WIN32)
    add_definitions(-DBUILDING_DLL)
    set(chibi-scheme-exclude-modules
        # Following modules are not compatible with Win32
        lib/chibi/net.sld
        lib/chibi/process.sld
        lib/chibi/stty.sld
        lib/chibi/system.sld
        lib/chibi/time.sld
        lib/chibi/pty.sld)
endif()

#
# Sources
#

set(chibi-scheme-srcs
    # SEXP
    gc.c
    sexp.c
    bignum.c
    gc_heap.c

    # Eval
    opcodes.c
    vm.c
    eval.c
    simplify.c)

include_directories(
    include
    ${CMAKE_CURRENT_BINARY_DIR}/include)

#
# Bootstrap
#

add_executable(chibi-scheme-bootstrap
    ${chibi-scheme-srcs}
    main.c)

if(WIN32)
    target_link_libraries(chibi-scheme-bootstrap ws2_32)
endif()

if(CYGWIN OR WIN32)
    set(soext ".dll")
else()
    set(soext ".so")
endif()

#
# Generate modules
#

# FIXME: Currently, it depends on GLOB thus we have to re-run CMake
#        when we've gotten additional/removed library 

file(GLOB_RECURSE stubs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/lib 
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/*.stub)
file(GLOB_RECURSE slds RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} 
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/*.sld)
list(REMOVE_ITEM slds ${chibi-scheme-exclude-modules})

set(chibi-ffi ${CMAKE_CURRENT_SOURCE_DIR}/tools/chibi-ffi)
set(chibi-genstatic ${CMAKE_CURRENT_SOURCE_DIR}/tools/chibi-genstatic)

set(stuboutdir ${CMAKE_CURRENT_BINARY_DIR}/stubs/lib)
foreach(e ${stubs})
    get_filename_component(stubdir ${e} PATH)
    get_filename_component(basename ${e} NAME_WE)
    set(stubfile ${CMAKE_CURRENT_SOURCE_DIR}/lib/${e})
    set(stubdir ${stuboutdir}/${stubdir})
    set(stubout ${stubdir}/${basename}.c)
    file(MAKE_DIRECTORY ${stubdir})
    add_custom_command(OUTPUT ${stubout}
        COMMAND chibi-scheme-bootstrap
        ${chibi-ffi} ${stubfile} ${stubout}
        DEPENDS ${stubfile} ${chibi-ffi}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    list(APPEND stubouts ${stubout})
endforeach()
add_custom_target(chibi-scheme-stubs DEPENDS ${stubouts})

#
# Generate clib.c for SEXP_USE_STATIC_LIBS
#

string(REPLACE ";" "\n" genstatic-input "${slds}")
set(clibin ${CMAKE_CURRENT_BINARY_DIR}/clib-in.txt)
set(clibout ${CMAKE_CURRENT_BINARY_DIR}/clib.c)
set(genstatic-helper 
    ${CMAKE_CURRENT_LIST_DIR}/contrib/chibi-genstatic-helper.cmake)
file(WRITE ${clibin} "${genstatic-input}")

add_custom_command(OUTPUT ${clibout}
    COMMAND 
    ${CMAKE_COMMAND} 
    -DEXEC=$<TARGET_FILE:chibi-scheme-bootstrap>
    -DGENSTATIC=${chibi-genstatic}
    -DSTUBS=${clibin}
    -DOUT=${clibout}
    -P ${genstatic-helper}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS 
    chibi-scheme-bootstrap
    ${chibi-genstatic}
    ${genstatic-helper}
    ${slds})

#
# Core library
#

if(CHIBI_SCHEME_SHARED)
    set(libtype SHARED)
else()
    set(libtype STATIC)
endif()

add_library(${chibischemelib} ${libtype}
    ${chibi-scheme-srcs}
    ${clibout})

set_target_properties(${chibischemelib}
    PROPERTIES 
    COMPILE_DEFINITIONS "SEXP_USE_STATIC_LIBS=1")

add_dependencies(${chibischemelib} chibi-scheme-stubs)

if(WIN32 AND CHIBI_SCHEME_SHARED)
    target_link_libraries(${chibischemelib} ws2_32)
    target_compile_definitions(${chibischemelib} PUBLIC -DBUILDING_DLL=1)
endif()

function(bless_chibi_scheme_executable tgt)
    target_link_libraries(${tgt} ${chibischemelib})
    if(WIN32 AND NOT CHIBI_SCHEME_SHARED)
        target_link_libraries(${tgt} ws2_32)
    endif()
endfunction()

#
# Interpreter
#

include_directories(
    .
    ${stuboutdir}/..)
add_executable(chibi-scheme
    main.c)

bless_chibi_scheme_executable(chibi-scheme)

#
# Generate "chibi/install.h" 
#

if(CYGWIN OR WIN32)
    set(thePrefix "bin")
else()
    set(thePrefix "lib")
endif()

if(WIN32)
    set(pathsep "\\;")
else()
    set(pathsep ":")
endif()

if(WIN32)
    set(platform "windows")
else()
    set(platform "unknown")
endif()


set(default_module_path
    ""
    #"${CMAKE_INSTALL_PREFIX}/${thePrefix}${pathsep}${CMAKE_INSTALL_PREFIX}/bin"
    )

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/chibi)

file(WRITE
    ${CMAKE_CURRENT_BINARY_DIR}/include/chibi/install.h
    "#define sexp_so_extension \"${soext}\"
#define sexp_default_module_path \"${default_module_path}\"
#define sexp_platform \"${platform}\"
#define sexp_version \"\"
#define sexp_release_name \"${release}\"")

# 
# Testing
#

enable_testing()

set(chibi-scheme-tests
    r7rs-tests
    ## Not connected
    #division-tests
    #r5rs-tests
    #syntax-tests
    #unicode-tests
    ## Require threads
    # lib-tests
    )

foreach(e ${chibi-scheme-tests})
    add_test(NAME "${e}"
        COMMAND chibi-scheme tests/${e}.scm
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

file(GLOB_RECURSE srfi_tests RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/lib
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/srfi/*/test.sld)

file(GLOB_RECURSE chibi_scheme_tests RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/lib
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/chibi/*-test.sld)

set(testexcludes
    # Excluded tests
    chibi/filesystem-test
    chibi/memoize-test
    chibi/term/ansi-test
    chibi/weak-test

    # Not ported to Win32
    srfi/18/test # Threading
    chibi/doc-test # Depends (chibi time)
    chibi/log-test
    chibi/system-test
    chibi/tar-test # Depends (chibi system)
    chibi/process-test # Not applicable
    chibi/pty-test # Depends (chibi pty)
    )

set(testlibs)
foreach(e ${srfi_tests} ${chibi_scheme_tests})
    get_filename_component(pth ${e} PATH)
    get_filename_component(nam ${e} NAME_WE)
    list(APPEND testlibs ${pth}/${nam})
endforeach()
list(REMOVE_ITEM testlibs ${testexcludes})

foreach(e ${testlibs})
    string(REGEX REPLACE "/" "_" testname ${e})
    string(REGEX REPLACE "/" " " form ${e})
    add_test(NAME "lib_${testname}"
        COMMAND chibi-scheme -e "(import (${form}))"
        -e "(run-tests)"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

# 
# Testing (embedding)
#

add_executable(test-foreign-apply-loop
    tests/foreign/apply-loop.c)

bless_chibi_scheme_executable(test-foreign-apply-loop)

add_test(NAME "foreign-apply-loop"
    COMMAND test-foreign-apply-loop
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_executable(test-foreign-typeid
    tests/foreign/typeid.c)

bless_chibi_scheme_executable(test-foreign-typeid)

add_test(NAME "foreign-typeid"
    COMMAND test-foreign-typeid
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== Makefile ===
# -*- makefile-gmake -*-

.PHONY: dist mips-dist cleaner test test-all test-dist checkdefs debian snowballs init-dev
.DEFAULT_GOAL := all

CHIBI_VERSION ?= $(shell cat VERSION)
SOVERSION ?= $(CHIBI_VERSION)
SOVERSION_MAJOR ?= $(shell echo "$(SOVERSION)" | sed "s/\..*//")

CHIBI_FFI ?= $(CHIBI) -q tools/chibi-ffi
CHIBI_FFI_DEPENDENCIES ?= $(CHIBI_DEPENDENCIES) tools/chibi-ffi

CHIBI_DOC ?= $(CHIBI) tools/chibi-doc
CHIBI_DOC_DEPENDENCIES ?= $(CHIBI_DEPENDENCIES) tools/chibi-doc

GENSTATIC ?= ./tools/chibi-genstatic

CHIBI ?= LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" DYLD_LIBRARY_PATH=".:$(DYLD_LIBRARY_PATH)" CHIBI_IGNORE_SYSTEM_PATH=1 CHIBI_MODULE_PATH=lib ./chibi-scheme$(EXE)
CHIBI_DEPENDENCIES = ./chibi-scheme$(EXE)

SNOW_CHIBI ?= tools/snow-chibi

########################################################################

CHIBI_COMPILED_LIBS = lib/chibi/filesystem$(SO) lib/chibi/weak$(SO) \
	lib/chibi/heap-stats$(SO) lib/chibi/disasm$(SO) lib/chibi/ast$(SO) \
	lib/chibi/json$(SO) lib/chibi/emscripten$(SO)
CHIBI_POSIX_COMPILED_LIBS = lib/chibi/process$(SO) lib/chibi/time$(SO) \
	lib/chibi/system$(SO) lib/chibi/stty$(SO) lib/chibi/pty$(SO) \
	lib/chibi/net$(SO) lib/srfi/18/threads$(SO)
CHIBI_WIN32_COMPILED_LIBS = lib/chibi/win32/process-win32$(SO)
CHIBI_CRYPTO_COMPILED_LIBS = lib/chibi/crypto/crypto$(SO)
CHIBI_IO_COMPILED_LIBS = lib/chibi/io/io$(SO)
CHIBI_OPT_COMPILED_LIBS = lib/chibi/optimize/rest$(SO) \
	lib/chibi/optimize/profile$(SO)
EXTRA_COMPILED_LIBS ?=

COMPILED_LIBS = $(CHIBI_COMPILED_LIBS) $(CHIBI_IO_COMPILED_LIBS) \
	$(CHIBI_OPT_COMPILED_LIBS) $(CHIBI_CRYPTO_COMPILED_LIBS) \
	$(EXTRA_COMPILED_LIBS) \
	lib/srfi/27/rand$(SO) lib/srfi/151/bit$(SO) \
	lib/srfi/39/param$(SO) lib/srfi/69/hash$(SO) lib/srfi/95/qsort$(SO) \
	lib/srfi/98/env$(SO) lib/srfi/144/math$(SO) lib/srfi/160/uvprims$(SO) \
	lib/scheme/bytevector$(SO) lib/scheme/time$(SO)

BASE_INCLUDES = include/chibi/sexp.h include/chibi/features.h include/chibi/install.h include/chibi/bignum.h
INCLUDES = $(BASE_INCLUDES) include/chibi/eval.h include/chibi/gc_heap.h

MODULE_DOCS := app ast base64 bytevector config crypto/md5 crypto/rsa \
	crypto/sha2 diff disasm doc edit-distance equiv filesystem generic \
	heap-stats io iset/base iset/constructors iset/iterators json loop \
	match math/prime memoize mime modules net net/http-server net/servlet \
	parse pathname process repl scribble string stty sxml system temp-file \
	test time trace type-inference uri weak monad/environment crypto/sha2

IMAGE_FILES = lib/chibi.img lib/red.img lib/snow.img

HTML_LIBS = $(MODULE_DOCS:%=doc/lib/chibi/%.html) doc/lib/srfi/166/base.html

META_FILES = lib/.chibi.meta lib/.srfi.meta lib/.scheme.meta

########################################################################
# This includes the rules to build optional libraries.
# It also pulls in Makefile.detect for platform detection.

include Makefile.libs

########################################################################

all: chibi-scheme$(EXE) all-libs chibi-scheme.pc $(META_FILES)

# Please run this if you want to contribute.
init-dev:
	git config core.hooksPath .githooks

js: js/chibi.js

js/chibi.js: chibi-scheme-emscripten chibi-scheme-static.bc js/pre.js js/post.js js/exported_functions.json
	emcc -O0 chibi-scheme-static.bc -o $@ -s ALLOW_MEMORY_GROWTH=1 -s MODULARIZE=1 -s EXPORT_NAME=\"Chibi\" -s EXPORTED_FUNCTIONS=@js/exported_functions.json `find  lib -type f \( -name "*.scm" -or -name "*.sld" \) -printf " --preload-file %p"` -s 'EXTRA_EXPORTED_RUNTIME_METHODS=["ccall", "cwrap"]' --pre-js js/pre.js --post-js js/post.js

chibi-scheme-static.bc:
	emmake $(MAKE) PLATFORM=emscripten CHIBI_DEPENDENCIES= CHIBI=./chibi-scheme-emscripten PREFIX= CFLAGS=-O2 SEXP_USE_DL=0 EXE=.bc SO=.bc CPPFLAGS="-DSEXP_USE_STRICT_TOPLEVEL_BINDINGS=1 -DSEXP_USE_ALIGNED_BYTECODE=1 -DSEXP_USE_STATIC_LIBS=1 -DSEXP_USE_STATIC_LIBS_NO_INCLUDE=0" clibs.c chibi-scheme-static.bc

chibi-scheme-emscripten: VERSION
	$(MAKE) dist-clean
	$(MAKE) chibi-scheme-static PLATFORM=emscripten SEXP_USE_DL=0
	(tempfile="`mktemp -t chibi.XXXXXX`" && \
	mv chibi-scheme-static$(EXE) "$$tempfile" && \
	$(MAKE) dist-clean; \
	mv "$$tempfile" chibi-scheme-emscripten)

include/chibi/install.h: Makefile
	echo '#define sexp_so_extension "'$(SO)'"' > $@
	echo '#define sexp_default_module_path "'$(MODDIR):$(BINMODDIR):$(SNOWMODDIR):$(SNOWBINMODDIR)'"' >> $@
	echo '#define sexp_platform "'$(PLATFORM)'"' >> $@
	echo '#define sexp_version "'$(CHIBI_VERSION)'"' >> $@
	echo '#define sexp_release_name "'`cat RELEASE`'"' >> $@

%.o: %.c $(BASE_INCLUDES)
	$(CC) -c $(XCPPFLAGS) $(XCFLAGS) $(CLIBFLAGS) -o $@ $<

gc-ulimit.o: gc.c $(BASE_INCLUDES)
	$(CC) -c $(XCPPFLAGS) $(XCFLAGS) $(CLIBFLAGS) -DSEXP_USE_LIMITED_MALLOC -o $@ $<

sexp-ulimit.o: sexp.c $(BASE_INCLUDES)
	$(CC) -c $(XCPPFLAGS) $(XCFLAGS) $(CLIBFLAGS) -DSEXP_USE_LIMITED_MALLOC -o $@ $<

main.o: main.c $(INCLUDES)
	$(CC) -c $(XCPPFLAGS) $(XCFLAGS) -o $@ $<

SEXP_OBJS = gc.o sexp.o bignum.o gc_heap.o
SEXP_ULIMIT_OBJS = gc-ulimit.o sexp-ulimit.o bignum.o gc_heap.o
EVAL_OBJS = opcodes.o vm.o eval.o simplify.o

libchibi-sexp$(SO): $(SEXP_OBJS)
	$(CC) $(CLIBFLAGS) $(CLINKFLAGS) -o $@ $^ $(XLDFLAGS)

libchibi-scheme$(SO_VERSIONED_SUFFIX): $(SEXP_OBJS) $(EVAL_OBJS)
	$(CC) $(CLIBFLAGS) $(CLINKFLAGS) $(LIBCHIBI_FLAGS) -o $@ $^ $(XLDFLAGS)

libchibi-scheme$(SO_MAJOR_VERSIONED_SUFFIX): libchibi-scheme$(SO_VERSIONED_SUFFIX)
	$(LN) $< $@

libchibi-scheme$(SO): libchibi-scheme$(SO_MAJOR_VERSIONED_SUFFIX)
	$(LN) $< $@

libchibi-scheme.a: $(SEXP_OBJS) $(EVAL_OBJS)
	$(AR) rcs $@ $^

chibi-scheme$(EXE): main.o libchibi-scheme$(SO)
	$(CC) $(XCPPFLAGS) $(XCFLAGS) $(LDFLAGS) -o $@ $< -L. $(RLDFLAGS) -lchibi-scheme

chibi-scheme-static$(EXE): main.o $(SEXP_OBJS) $(EVAL_OBJS)
	$(CC) $(XCFLAGS) $(STATICFLAGS) -o $@ $^ $(LDFLAGS) $(GCLDFLAGS) -lm -ldl -lutil

chibi-scheme-ulimit$(EXE): main.o $(SEXP_ULIMIT_OBJS) $(EVAL_OBJS)
	$(CC) $(XCFLAGS) $(STATICFLAGS) -o $@ $^ $(LDFLAGS) $(GCLDFLAGS) -lm -ldl -lutil

clibs.c: $(GENSTATIC) $(CHIBI_DEPENDENCIES) $(COMPILED_LIBS:%$(SO)=%.c)
	$(GIT) ls-files lib | $(GREP) .sld | $(CHIBI) -q $(GENSTATIC) > $@

chibi-scheme.pc: chibi-scheme.pc.in
	echo "# pkg-config" > chibi-scheme.pc
	echo "prefix=$(PREFIX)" >> chibi-scheme.pc
	echo "exec_prefix=\$${prefix}" >> chibi-scheme.pc
	echo "libdir=$(LIBDIR)" >> chibi-scheme.pc
	echo "includedir=\$${prefix}/include" >> chibi-scheme.pc
	echo "version=$(CHIBI_VERSION)" >> chibi-scheme.pc
	echo "" >> chibi-scheme.pc
	cat chibi-scheme.pc.in >> chibi-scheme.pc

# A special case, this needs to be linked with the LDFLAGS in case
# we're using Boehm.
lib/chibi/ast$(SO): lib/chibi/ast.c $(INCLUDES) libchibi-scheme$(SO)
	-$(CC) $(CLIBFLAGS) $(CLINKFLAGS) $(XCPPFLAGS) $(XCFLAGS) $(LDFLAGS) -o $@ $< $(GCLDFLAGS) -L. $(RLDFLAGS) -lchibi-scheme

lib/chibi/crypto/crypto.c: lib/chibi/crypto/sha2.c
lib/chibi/filesystem.c: lib/chibi/filesystem_win32_shim.c
lib/chibi/io/io.c: lib/chibi/io/port.c
lib/chibi/net.c: lib/chibi/accept.c
lib/chibi/process.c: lib/chibi/signal.c
lib/srfi/144/math.c: lib/srfi/144/lgamma_r.c

lib/chibi.img: $(CHIBI_DEPENDENCIES) all-libs
	$(CHIBI) -d $@

lib/snow.img: $(CHIBI_DEPENDENCIES) all-libs
	$(CHIBI) -mchibi.snow.commands -d $@

lib/red.img: $(CHIBI_DEPENDENCIES) all-libs
	$(CHIBI) -xscheme.red -mchibi.repl -d $@

doc: doc/chibi.html doc-libs

%.html: %.scrbl $(CHIBI_DOC_DEPENDENCIES)
	$(CHIBI_DOC) --html $< > $@

lib/.%.meta: lib/%/ tools/generate-install-meta.scm $(CHIBI_DEPENDENCIES)
	-$(FIND) $< -name \*.sld | \
	 $(CHIBI) tools/generate-install-meta.scm $(CHIBI_VERSION) > $@

########################################################################
# Dist builds - rules to build generated files included in distribution
# (currently just char-sets since it takes a long time and we don't want
# to bundle the raw Unicode files or require a net connection to build).

data/%.txt:
	curl --silent http://www.unicode.org/Public/UNIDATA/$*.txt > $@

build-lib/chibi/char-set/derived.scm: data/UnicodeData.txt data/DerivedCoreProperties.txt chibi-scheme$(EXE)
	$(CHIBI) tools/extract-unicode-props.scm --default > $@

build-lib/chibi/char-set/width.scm: data/UnicodeData.txt data/EastAsianWidth.txt chibi-scheme$(EXE)
	$(CHIBI) tools/extract-unicode-props.scm Zero-Width=Mn > $@
	$(CHIBI) tools/extract-unicode-props.scm -d data/EastAsianWidth.txt Full-Width=F@1,W@1 Ambiguous-Width=A@1 >> $@

lib/chibi/char-set/ascii.scm: build-lib/chibi/char-set/derived.scm chibi-scheme$(EXE)
	$(CHIBI) -Abuild-lib tools/optimize-char-sets.scm --ascii chibi.char-set.compute > $@

lib/chibi/char-set/full.scm: build-lib/chibi/char-set/derived.scm chibi-scheme$(EXE)
	$(CHIBI) -Abuild-lib tools/optimize-char-sets.scm chibi.char-set.compute > $@

lib/chibi/show/width.scm: build-lib/chibi/char-set/width.scm chibi-scheme$(EXE)
	$(CHIBI) -Abuild-lib tools/optimize-char-sets.scm --predicate chibi.char-set.width > $@

lib/scheme/char/case-offsets.scm: data/UnicodeData.txt data/CaseFolding.txt chibi-scheme$(EXE) all-libs
	$(CHIBI) tools/extract-case-offsets.scm data/UnicodeData.txt data/CaseFolding.txt > $@

lib/scheme/char/special-casing.scm: data/CaseFolding.txt data/SpecialCasing.txt chibi-scheme$(EXE) all-libs
	$(CHIBI) tools/extract-special-casing.scm data/CaseFolding.txt data/SpecialCasing.txt > $@

########################################################################
# Tests

checkdefs:
	@for d in $(D); do \
	    if ! $(GREP) -q " SEXP_USE_$${d%%=*} " include/chibi/features.h; then \
		echo "WARNING: unknown definition $$d"; \
	    fi; \
	done

test-basic: chibi-scheme$(EXE)
	@for f in tests/basic/*.scm; do \
	    $(CHIBI) -xchibi $$f >$${f%.scm}.out 2>$${f%.scm}.err; \
	    if $(DIFF) -q $(DIFFOPTS) $${f%.scm}.out $${f%.scm}.res; then \
		echo "[PASS] $${f%.scm}"; \
	    else \
		echo "[FAIL] $${f%.scm}"; \
	    fi; \
	done

test-memory: chibi-scheme-ulimit$(EXE)
	./tests/memory/memory-tests.sh

test-build:
	MAKE=$(MAKE) ./tests/build/build-tests.sh

test-run:
	./tests/run/command-line-tests.sh

test-ffi: chibi-scheme$(EXE)
	$(CHIBI) tests/ffi/ffi-tests.scm

test-snow: chibi-scheme$(EXE) $(IMAGE_FILES)
	$(CHIBI) tests/snow/snow-tests.scm

test-unicode: chibi-scheme$(EXE)
	$(CHIBI) -xchibi tests/unicode-tests.scm

test-division: chibi-scheme$(EXE)
	$(CHIBI) tests/division-tests.scm

test-libs: chibi-scheme$(EXE)
	@echo "\e[1mloading tests first, it may take a while to see output...\e[0m"
	$(CHIBI) tests/lib-tests.scm

test-r5rs: chibi-scheme$(EXE)
	$(CHIBI) -xchibi tests/r5rs-tests.scm

test-r7rs: chibi-scheme$(EXE)
	$(CHIBI) tests/r7rs-tests.scm

test: test-r7rs

test-safe-string-cursors: chibi-scheme$(EXE)
	$(CHIBI) -Dsafe-string-cursors tests/r7rs-tests.scm
	$(CHIBI) -Dsafe-string-cursors tests/lib-tests.scm

test-all: test test-libs test-ffi test-division

test-dist: test-all test-memory test-build

bench-gabriel: chibi-scheme$(EXE)
	./benchmarks/gabriel/run.sh

########################################################################
# Packaging

clean: clean-libs
	-$(RM) *.o *.i *.s *.bc *.8 tests/basic/*.out tests/basic/*.err \
	    tests/run/*.out tests/run/*.err

cleaner: clean
	-$(RM) chibi-scheme$(EXE) chibi-scheme-static$(EXE) chibi-scheme-ulimit$(EXE) \
	    $(IMAGE_FILES) libchibi-scheme*$(SO) *.a *.pc \
	    libchibi-scheme$(SO_VERSIONED_SUFFIX) \
	    libchibi-scheme$(SO_MAJOR_VERSIONED_SUFFIX) \
	    include/chibi/install.h lib/.*.meta \
	    chibi-scheme-emscripten \
	    js/chibi.* \
	    $(shell $(FIND) lib -name \*.o)

dist-clean: dist-clean-libs cleaner

install-base: all
	$(MKDIR) $(DESTDIR)$(BINDIR)
	$(INSTALL_EXE) -m0755 chibi-scheme$(EXE) $(DESTDIR)$(BINDIR)/
	$(INSTALL) -m0755 tools/chibi-ffi $(DESTDIR)$(BINDIR)/
	$(INSTALL) -m0755 tools/chibi-doc $(DESTDIR)$(BINDIR)/
	$(INSTALL) -m0755 tools/snow-chibi $(DESTDIR)$(BINDIR)/
	$(INSTALL) -m0755 tools/snow-chibi.scm $(DESTDIR)$(BINDIR)/

=== debian/changelog ===
chibi-scheme (0.9.1-3ubuntu0.22.04.1) jammy; urgency=medium

  * d/control: Add runtime dependency to fix install failure. (LP: #2009694)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 15 Apr 2024 19:05:14 +0100

chibi-scheme (0.9.1-3) unstable; urgency=medium

  * Adjust debian/rules to upstream Makefile API change

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 25 Nov 2020 20:10:04 +0000

chibi-scheme (0.9.1-2) unstable; urgency=medium

  * Update renamed lintian tag names in lintian overrides.
  * Bump policy
  * Track upstream changes including bug fix for library symbols missing
    on 32-bit architectures (closes: #972956)
  * Forward port patches (one spelling correct merged upstream)

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 25 Nov 2020 16:33:43 +0000

chibi-scheme (0.9.1-1) unstable; urgency=medium

  * Initial Debian release. (Closes: #928753)
    - Thanks to Alexei Lozovsky <me@ilammy.net> who did all the hard lifting.

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Sep 2020 14:22:27 +0100

=== debian/control ===
Source: chibi-scheme
Section: lisp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/ashinn/chibi-scheme
Vcs-Browser: https://salsa.debian.org/scheme-team/chibi-scheme
Vcs-Git: https://salsa.debian.org/scheme-team/chibi-scheme.git

Package: chibi-scheme
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: chibi-scheme-common
Suggests: chibi-scheme-doc
Description: embeddable Scheme interpreter
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides REPL and interpreter "chibi-scheme"
 as well as tools for documenting Scheme code ("chibi-doc"),
 generating FFI bindings ("chibi-ffi"),
 and managing Scheme packages ("snow-chibi").

Package: chibi-scheme-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: chibi-scheme
Description: embeddable Scheme interpreter (documentation)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides documentation on the interpreter library,
 FFI interfaces, and built-in extension modules.

Package: chibi-scheme-common
Architecture: all
Depends: libchibi-scheme-ffi (>= 0.9.1), ${misc:Depends}
Description: embeddable Scheme interpreter (standard libraries)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the standard library for R7RS Scheme, as well as
 some additional extension libraries.

Package: chibi-scheme-images
Architecture: all
Depends: chibi-scheme-common (= ${binary:Version}), ${misc:Depends}, chibi-scheme (>= ${source:Version})
Description: embeddable Scheme interpreter (standard library images)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 A dummy package providing preloaded images for use with "chibi-scheme -i".
 They allow faster startup times when using common library sets.

Package: libchibi-scheme0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: embeddable Scheme interpreter (shared library)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the core shared library for applications that
 are using Chibi.

Package: libchibi-scheme-dev
Section: libdevel
Architecture: any
Depends: libchibi-scheme0 (= ${binary:Version}), ${misc:Depends}
Suggests: chibi-scheme-doc
Description: embeddable Scheme interpreter (development files)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the header files, libraries, and symbolic links
 necessary to build applications that use Chibi-Scheme and extension
 modules for Chibi-Scheme.

Package: libchibi-scheme-ffi
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: chibi-scheme-common
Description: embeddable Scheme interpreter (native modules)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides native binary modules required by some of the
 libraries in Chibi's standard package.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# This defines and exports DEB_HOST_MULTIARCH and a host of other garbage
include /usr/share/dpkg/default.mk

# Manually implement multiarch support here since debhelper seems to pass
# this information in a proper form only to the Autoconf build system.
# When using "--buildsystem=make", no multiarch support is added.
# Chibi does not support Autoconf so we have to fix up the paths here.
EXTRA_ARGS += prefix="/usr"
EXTRA_ARGS += libdir="/usr/lib/$(DEB_HOST_MULTIARCH)"
EXTRA_ARGS += SNOWPREFIX="/usr/local"
EXTRA_ARGS += SNOWLIBDIR="/usr/local/lib/$(DEB_HOST_MULTIARCH)"

%:
	dh $@

override_dh_auto_build:
# Build the static library first. It requires special compilation flags without
# -fPIC and dlopen() support.
	dh_auto_build -- libchibi-scheme.a $(EXTRA_ARGS) CLIBFLAGS= SEXP_USE_DL=0
	$(MAKE) clean
# After cleaning up the object files we can build everything else.
	dh_auto_build -- all $(EXTRA_ARGS)
# Additionally, build the HTML documentation for Chibi and libraries.
	$(MAKE) doc

# Run a bit more tests than "make test" usually does to verify
# SRFI libraries and FFI things.
override_dh_auto_test:
	dh_auto_test -- test-all test-unicode $(EXTRA_ARGS)

override_dh_auto_install:
# Make sure that "make install" does not build and install image files.
# Those will be created on the user machine at package configuration time.
	dh_auto_install -- $(EXTRA_ARGS) IMAGE_FILES=

=== debian/watch ===
version=4
https://github.com/ashinn/@PACKAGE@/releases \
 .*/v?@ANY_VERSION@@ARCHIVE_EXT@
